/**
 * ProgrammBeendenHorcher.java
 * eu.gronos.kostenrechner (Kostenrechner)
 */
package eu.gronos.kostenrechner.controller;

import java.awt.event.WindowEvent;

import javax.swing.JOptionPane;

import eu.gronos.kostenrechner.Kostenrechner;
import eu.gronos.kostenrechner.view.RechnerhammerIcons;

/**
 * Speichert Routinen, die beim Schließen des Fensters eine Abfrage ausführen.
 *
 * @author Peter Schuster (setrok)
 * @date 11 Nov 2018
 *
 */
public class BeendenHorcher extends AllzweckHorcher {
	@Override
	public void windowClosing(WindowEvent e) {
		BeendenHorcher.beendeKostenrechner();
	}

	@Override
	public void windowClosed(WindowEvent e) {
		Kostenrechner.getLogger().info(
				Kostenrechner.KOSTENRECHNER_TITLE + Kostenrechner.KOSTENRECHNER_VERSION + " beendet. " + e.toString());
		System.exit(0);
	}

	/**
	 * Die Methode fragt vor dem Beenden ab
	 * 
	 * @TODO TODO in zwei Methoden aufteilen: eine für WindowClosing und die andere
	 *       für WindowClosed
	 * 
	 */
	public static void beendeKostenrechner() {
		if (Kostenrechner.getInstance() == null)
			System.exit(0);
		else {
			int antwort;
			antwort = JOptionPane.showConfirmDialog(Kostenrechner.getInstance(),
					String.format("Sind Sie sicher?%nDies beendet %s!%n%nLog-File: %s", Kostenrechner.KOSTENRECHNER_TITLE, Kostenrechner.getLogFileName()),
					Kostenrechner.KOSTENRECHNER_TITLE + " beenden?", JOptionPane.OK_CANCEL_OPTION,
					JOptionPane.QUESTION_MESSAGE, RechnerhammerIcons.getRechnerhammer64());
			if (antwort == JOptionPane.OK_OPTION) {
				Kostenrechner.getInstance().setVisible(false);
				Kostenrechner.getInstance().dispose();
			}
		}
	}
}