/*
 * HinzufuegenAbbrechenAction.java
 * eu.gronos.kostenrechner.view (Kostenrechner)
 */
package eu.gronos.kostenrechner.controller;

import java.awt.event.ActionEvent;

import javax.swing.Action;
import javax.swing.KeyStroke;

import eu.gronos.kostenrechner.view.HinzufuegenDialog;

/**
 * Die {@link Action} bricht den {@link HinzufuegenDialog} ab.
 *
 * @author Peter Schuster (setrok)
 * @date 5 Mar 2019
 *
 */
public class HinzufuegenAbbrechenAction<E> extends BeschriebeneAktion {
	private final HinzufuegenDialog<E> dialog;
	private static final long serialVersionUID = 7626690970693233716L;

	/**
	 * Konstruktor.
	 * 
	 * @param dialog           ein {@link HinzufuegenDialog}
	 * @param name             {@link Action#NAME}
	 * @param shortDescription {@link Action#SHORT_DESCRIPTION}
	 * @param mnemonic         {@link Action#MNEMONIC_KEY}
	 * @param actionCommandKey {@link Action#ACTION_COMMAND_KEY}
	 * @param acceleratorKey   {@link Action#ACCELERATOR_KEY}
	 */
	public HinzufuegenAbbrechenAction(HinzufuegenDialog<E> dialog, String name, String shortDescription, int mnemonic,
			String actionCommandKey, KeyStroke acceleratorKey) {
		super(name, shortDescription, mnemonic, actionCommandKey, acceleratorKey);
		this.dialog = dialog;
	}

	@Override
	public void actionPerformed(ActionEvent ae) {
		dialog.fensterSchliessenBeiAbbruch();
	}
}