/**
 * InfoAction.java
 * eu.gronos.kostenrechner.view (Kostenrechner)
 */
package eu.gronos.kostenrechner.controller;

import java.awt.event.ActionEvent;
import java.awt.event.KeyEvent;

import javax.swing.Action;

import eu.gronos.kostenrechner.view.AktionenJMenu;

/**
 * Die Action ruft den Dialog hinter {@link AktionenJMenu#ueberKostenrechner()}
 * auf, der Informationen über das Programm anzeigt. {@link KeyEvent#VK_U}
 *
 * @author Peter Schuster (setrok)
 * @date 11 Nov 2018
 *
 */
public class InfoAction extends BeschriebeneAktion {
	private static final long serialVersionUID = -7370964238649394812L;

	/**
	 * Konstruktor.
	 * 
	 * @param name             {@link Action#NAME}
	 * @param shortDescription {@link Action#SHORT_DESCRIPTION}
	 * @param mnemonic         {@link Action#MNEMONIC_KEY}
	 * @param actionCommandKey {@link Action#ACTION_COMMAND_KEY}
	 */
	public InfoAction(String name, String shortDescription, int mnemonic, String actionCommandKey) {
		super(name, shortDescription, mnemonic, actionCommandKey);
	}

	@Override
	public void actionPerformed(ActionEvent e) {
		AktionenJMenu.ueberKostenrechner();
	}
}