/**
 * AssistentWbkUnterliegenHorcher.java
 * eu.gronos.kostenrechner.view.baumbach (Kostenrechner)
 */
package eu.gronos.kostenrechner.controller.baumbach;

import javax.swing.JCheckBox;
import javax.swing.JFormattedTextField;
import javax.swing.JList;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

import eu.gronos.kostenrechner.model.tenordaten.Beteiligter;
import eu.gronos.kostenrechner.view.baumbach.BaumbachAssistentDialog;

/**
 * Horcher, damit sich die Checkbox so verhält:
 * 
 * Wenn nicht ausgewählt, muss die Liste ausgegraut werden und die Werte /
 * Markierung geleert werden
 *
 * @author Peter Schuster (setrok)
 * @date 21 Feb 2019
 *
 */
public class AssistentWbkUnterliegenHorcher implements ChangeListener {
	private final BaumbachAssistentDialog dialog;
	private final JList<Beteiligter> liste;// = dialog.liWkGesamtschuldner;
	private final JFormattedTextField textField;// = dialog.ftfWkUnterliegen;

	public AssistentWbkUnterliegenHorcher(BaumbachAssistentDialog dialog, JList<Beteiligter> liste,
			JFormattedTextField textField) {
		this.dialog = dialog;
		this.liste = liste;
		this.textField = textField;
	}

	@Override
	public void stateChanged(ChangeEvent e) {
		boolean b = ((JCheckBox) e.getSource()).isSelected();
		liste.setEnabled(b);
		textField.setEnabled(b);
		if (!b) {
			liste.setSelectedIndex(-1);
			textField.setText(Double.toString(dialog.getWkGesamtUnterliegen()));
		}

	}
}