/**
 * AssistentWeiterAction.java
 * eu.gronos.kostenrechner.view.baumbach (Kostenrechner)
 */
package eu.gronos.kostenrechner.controller.baumbach;

import java.awt.event.ActionEvent;

import javax.swing.JComponent;
import javax.swing.KeyStroke;

import eu.gronos.kostenrechner.controller.BeschriebeneAktion;
import eu.gronos.kostenrechner.view.baumbach.BaumbachAssistentDialog;

/**
 * Alle Eingaben parsen (und Daten übergeben).
 * 
 * Wenn der jeweils letzte Zustand erreicht ist, Verhalten wie okButton.
 * 
 * Sonst dann den Zustand erhöhen.
 * 
 * Bestimmte Zustände (Anzahl der Parteien) müssen übersprungen werden, wenn
 * eine XJustiz-Datei importiert wird.
 *
 * @author Peter Schuster (setrok)
 * @date 21 Feb 2019
 *
 */
public class AssistentWeiterAction extends BeschriebeneAktion {
	private final BaumbachAssistentDialog dialog;
	private static final long serialVersionUID = -1432886554037727631L;

	public AssistentWeiterAction(BaumbachAssistentDialog dialog, String name, String shortDescription, int mnemonic,
			String actionCommandKey, KeyStroke acceleratorKey) {
		super(name, shortDescription, mnemonic, actionCommandKey, acceleratorKey);
		this.dialog = dialog;
	}

	@Override
	public void actionPerformed(ActionEvent e) {
		JComponent component = (JComponent) e.getSource();
		// Alle Eingaben parsen (und Daten übergeben)
		if (!dialog.parseEingabe(dialog.getZustand(), dialog.getVerfahrensDatenContainer() != null))
			return;
		if (dialog.getZustand() >= dialog.getHoechsterZustand() - 1)
		{
			/*
			 * Wenn der jeweils letzte Zustand erreicht ist, Verhalten wie okButton
			 */
			dialog.performOkAction(e);
		} else {
			/* Sonst dann den Zustand erhöhen */
			dialog.setZustand(dialog.getZustand() + 1);
			if (dialog.getVerfahrensDatenContainer() != null)
				/*
				 * Bestimmte Zustände müssen bei Import übersprungen werden:
				 */
				if ((dialog.getZustand() == 1 || dialog.getZustand() == 2))
					dialog.setZustand(3);
				else if ((dialog.getZustand() == 6 || dialog.getZustand() == 7))
					dialog.setZustand(8);
			dialog.zustandAnzeigen(dialog.getZustand());
			component.requestFocusInWindow();
		}
	}
}