/**
 * StreitgenossenAssistentAction.java
 * eu.gronos.kostenrechner.view.panel (Kostenrechner)
 */
package eu.gronos.kostenrechner.controller.baumbach;

import java.awt.event.ActionEvent;
import java.awt.event.KeyEvent;

import javax.swing.Action;

import eu.gronos.kostenrechner.Kostenrechner;
import eu.gronos.kostenrechner.controller.BeschriebeneAktion;
import eu.gronos.kostenrechner.interfaces.StreitgenossenTabellenBehandelnd;
import eu.gronos.kostenrechner.model.tenordaten.VerfahrensDatenContainer;
import eu.gronos.kostenrechner.view.baumbach.BaumbachAssistentDialog;
import eu.gronos.kostenrechner.view.baumbach.StreitgenossenPanel;

/**
 * {@link BeschriebeneAktion}, die den {@link BaumbachAssistentDialog} aufruft!
 * {@link KeyEvent#VK_A}
 * 
 * @author Peter Schuster (setrok)
 * @date 10.11.2018
 *
 */
public class StreitgenossenAssistentAction extends BeschriebeneAktion {
	private final StreitgenossenTabellenBehandelnd panel;
	private static final long serialVersionUID = 3372100502718641247L;

	/**
	 * Konstruktor:
	 * 
	 * @param name             {@link Action#NAME}
	 * @param shortDescription {@link Action#SHORT_DESCRIPTION}
	 * @param mnemonic         {@link Action#MNEMONIC_KEY}
	 * @param actionCommandKey {@link Action#ACTION_COMMAND_KEY}
	 * @param panel            {@link StreitgenossenPanel}
	 */
	public StreitgenossenAssistentAction(StreitgenossenTabellenBehandelnd panel, String name, String shortDescription,
			int mnemonic, String actionCommandKey) {
		super(name, shortDescription, mnemonic, actionCommandKey);
		this.panel = panel;
	}

	@Override
	public void actionPerformed(ActionEvent ae) {
		// this.panel.getKostenrechner(),
		BaumbachAssistentDialog bad = new BaumbachAssistentDialog(Kostenrechner.getInstance(), 
				panel.isWiderKlageAnzeigen());
		VerfahrensDatenContainer container = bad.showDialog();
		if (container != null)
			panel.setzeWerte(container.streitgenossen);
	}
}