/**
 * StreitgenossenGesamtschuldnerBkAction.java
 * eu.gronos.kostenrechner.view.panel (Kostenrechner)
 */
package eu.gronos.kostenrechner.controller.baumbach;

import java.awt.event.ActionEvent;

import javax.swing.Action;

import eu.gronos.kostenrechner.controller.BeschriebeneAktion;
import eu.gronos.kostenrechner.interfaces.StreitgenossenTabellenBehandelnd;
import eu.gronos.kostenrechner.model.baumbach.BaumbachGesamtschuldnerschaft;
import eu.gronos.kostenrechner.model.tenordaten.Beteiligter;
import eu.gronos.kostenrechner.view.baumbach.GesamtschuldnerDialog;
import eu.gronos.kostenrechner.view.baumbach.StreitgenossenPanel;
import eu.gronos.kostenrechner.view.helpanderror.FehlerDialog;

/**
 * Die Action fügt eine gesamtschuldnerische Verurteilung zur Tabelle der
 * Beklagten hinzu.
 *
 * @author Peter Schuster (setrok)
 * @date 10.11.2018
 *
 */
public class StreitgenossenGesamtschuldnerBkAction extends BeschriebeneAktion {
	private final StreitgenossenTabellenBehandelnd panel;
	private static final long serialVersionUID = 3348162188610732190L;

	/**
	 * Konstruktor.
	 * 
	 * @param name             {@link Action#NAME}
	 * @param shortDescription {@link Action#SHORT_DESCRIPTION}
	 * @param mnemonic         {@link Action#MNEMONIC_KEY}
	 * @param actionCommandKey {@link Action#ACTION_COMMAND_KEY}
	 * @param panel            {@link StreitgenossenPanel}
	 */
	public StreitgenossenGesamtschuldnerBkAction(StreitgenossenTabellenBehandelnd panel, String name,
			String shortDescription, int mnemonic, String actionCommandKey) {
		super(name, shortDescription, mnemonic, actionCommandKey);
		this.panel = panel;
	}

	@Override
	public void actionPerformed(ActionEvent ae) {
		try {
			GesamtschuldnerDialog gesamtschuldnerDialog = new GesamtschuldnerDialog(panel.getKostenrechner(),
					panel.getTableModel(Beteiligter.BEKLAGTE).getAllValues());// panel.btmBeklagte.
			BaumbachGesamtschuldnerschaft bt = gesamtschuldnerDialog.showDialog();
			if (bt != null)
				panel.getTableModel(Beteiligter.BEKLAGTE).addRow(bt);// panel.btmBeklagte
		} catch (IllegalArgumentException iae) {
			// Meldung, wenn noch keine Beteiligten in Tabelle
			new FehlerDialog(StreitgenossenPanel.FEHLER_GESAMTSCHULDNERSCHAFT, iae.getLocalizedMessage(), iae)
					.showDialog();
		}
	}
}