/**
 * LadeSkktx.java
 * eu.gronos.kostenrechner.view (Kostenrechner)
 */
package eu.gronos.kostenrechner.controller.files;

import java.awt.event.ActionEvent;

import javax.swing.Action;
import javax.swing.JFrame;
import javax.swing.KeyStroke;

import eu.gronos.kostenrechner.Kostenrechner;
import eu.gronos.kostenrechner.controller.BeschriebeneAktion;
import eu.gronos.kostenrechner.model.tenordaten.VerfahrensDatenContainer;
import eu.gronos.kostenrechner.view.BerechnungLadenSpeichernDialog;

/**
 * Die {@link Action} ruft einen {@link BerechnungLadenSpeichernDialog} auf. Der
 * lädt die Daten aller Registerkarten aus einer früher gespeicherten Berechnung
 * (Strg+O)
 *
 * @author Peter Schuster (setrok)
 * @date 11 Nov 2018
 *
 */
public class LadeSkktxAction extends BeschriebeneAktion {
	private static final long serialVersionUID = -2225698692818848010L;
	private JFrame frame;

	/**
	 * Konstruktor.
	 * 
	 * @param frame            ein {@link JFrame}, z.B. {@link Kostenrechner}
	 * @param name             {@link Action#NAME}
	 * @param shortDescription {@link Action#SHORT_DESCRIPTION}
	 * @param mnemonic         {@link Action#MNEMONIC_KEY}
	 * @param actionCommandKey {@link Action#ACTION_COMMAND_KEY}
	 * @param acceleratorKey   {@link Action#ACCELERATOR_KEY}
	 */
	public LadeSkktxAction(JFrame frame, String name, String shortDescription, int mnemonic, String actionCommandKey,
			KeyStroke acceleratorKey) {
		super(name, shortDescription, mnemonic, actionCommandKey, acceleratorKey);
		this.frame = frame;
	}

	@Override
	public void actionPerformed(ActionEvent ae) {
		final BerechnungLadenSpeichernDialog db = new BerechnungLadenSpeichernDialog();
		final VerfahrensDatenContainer container = db.ladeXmlDialog(this.frame);// menu.getKostenrechner()
		if (container != null)
			new VerfahrensDatenContainer2GUI().setzeAlleWerteAusContainer(container);
	}
}