/**
 * TenorZwischenablageAction.java
 * eu.gronos.kostenrechner.view.result (Kostenrechner)
 */
package eu.gronos.kostenrechner.controller.files;

import java.awt.event.ActionEvent;

import javax.swing.Action;
import javax.swing.KeyStroke;

import eu.gronos.kostenrechner.controller.BeschriebeneAktion;
import eu.gronos.kostenrechner.view.result.TenorDialog;

/**
 * {@link Action} zum Kopieren des Tenors in die Zwischenablage
 *
 * @author Peter Schuster (setrok)
 * @date 22 Nov 2018
 *
 */
public class RtfZwischenablageAction extends BeschriebeneAktion {
	private final TenorDialog dialog;
	private static final long serialVersionUID = -1470041456809868231L;

	/**
	 * Konstruktor.
	 * 
	 * @param dialog           Verweis auf {@link TenorDialog}
	 * @param name             {@link Action#NAME}
	 * @param shortDescription {@link Action#SHORT_DESCRIPTION}
	 * @param mnemonic         {@link Action#MNEMONIC_KEY}
	 * @param actionCommandKey {@link Action#ACTION_COMMAND_KEY}
	 * @param acceleratorKey   {@link Action#ACCELERATOR_KEY}
	 */
	public RtfZwischenablageAction(TenorDialog dialog, String name, String shortDescription, int mnemonic,
			String actionCommandKey, KeyStroke acceleratorKey) {
		super(name, shortDescription, mnemonic, actionCommandKey, acceleratorKey);
		this.dialog = dialog;
	}

	@Override
	public void actionPerformed(ActionEvent e) {
		dialog.getDocHelper().kopiereRtfInZwischenablage();
	}
}