/**
 * ForderungNeuAction.java
 * eu.gronos.kostenrechner.view.panel (Kostenrechner)
 */
package eu.gronos.kostenrechner.controller.forderungen;

import java.awt.event.ActionEvent;

import javax.swing.Action;

import eu.gronos.kostenrechner.controller.BeschriebeneAktion;
import eu.gronos.kostenrechner.model.forderungen.Forderung;
import eu.gronos.kostenrechner.view.forderungen.ForderungHinzufuegen;
import eu.gronos.kostenrechner.view.forderungen.ForderungsStaffelungPanel;

/**
 * Die {@link Action} fügt über {@link ForderungHinzufuegen} ein neues Angriffs-
 * oder Verteidigungsmittel zur Tabelle hinzu
 * 
 * @author Peter Schuster (setrok)
 * @date 04.11.2018
 *
 */
public class ForderungNeuAction extends BeschriebeneAktion {
	private final ForderungsStaffelungPanel panel;
	private static final long serialVersionUID = -25587531439255593L;

	/**
	 * Konstruktor.
	 * 
	 * @param panel            Verweis zum {@link ForderungsStaffelungPanel}
	 * @param name             {@link Action#NAME}
	 * @param shortDescription {@link Action#SHORT_DESCRIPTION}
	 * @param mnemonic         {@link Action#MNEMONIC_KEY}
	 * @param actionCommandKey {@link Action#ACTION_COMMAND_KEY}
	 */
	public ForderungNeuAction(ForderungsStaffelungPanel panel, String name, String shortDescription, int mnemonic,
			String actionCommandKey) {
		super(name, shortDescription, mnemonic, actionCommandKey);
		this.panel = panel;
	}

	@Override
	public void actionPerformed(ActionEvent e) {
		Forderung forderung = new ForderungHinzufuegen(panel.getKostenrechner()).showDialog();
		if (forderung != null)
			panel.ftm.addRow(forderung);
	}
}