/*
 * AuslagenHoeheVisibilityHorcher.java
 * eu.gronos.kostenrechner.view.gebuehren (Kostenrechner)
 */
package eu.gronos.kostenrechner.controller.gebuehren;

import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;

import javax.swing.JComboBox;
import javax.swing.JFormattedTextField;
import javax.swing.JLabel;
import javax.swing.JTextField;

import eu.gronos.kostenrechner.model.gebuehren.AuslagenTatbestand;
import eu.gronos.kostenrechner.model.gebuehren.GebuehrenErhoehungsTatbestand;
import eu.gronos.kostenrechner.model.gebuehren.GebuehrenTatbestand;
import eu.gronos.kostenrechner.view.gebuehren.GebuehrHinzufuegenDialog;

/**
 * Der Horcher hängt sich an eine {@link JComboBox} und passt entsprechend die
 * Sichtbarkeit des {@link JTextField}s an.
 *
 * @author Peter Schuster (setrok)
 * @date 3 May 2019
 *
 */
public class AuslagenHoeheVisibilityHorcher implements ItemListener {
	private final JFormattedTextField ftfAuslagenHoehe;
	private final JLabel lblAuslagenHoehe;
	private final JComboBox<GebuehrenTatbestand> cbGebuehrenListe;

	/**
	 * Konstruktor: TODO (kommentieren)
	 * @param cbGebuehrenListe TODO
	 * @param ftfAuslagenHoehe TODO
	 * @param lblAuslagenHoehe TODO
	 */
	public AuslagenHoeheVisibilityHorcher(JComboBox<GebuehrenTatbestand> cbGebuehrenListe, JFormattedTextField ftfAuslagenHoehe,
			JLabel lblAuslagenHoehe) {
		this.ftfAuslagenHoehe = ftfAuslagenHoehe;
		this.lblAuslagenHoehe = lblAuslagenHoehe;
		this.cbGebuehrenListe = cbGebuehrenListe;
	}

	@Override
	public void itemStateChanged(ItemEvent e) {
		adjustAuslagenHoeheVisibility();
	}

	/**
	 * Die Methode adjustVisibility dient dazu, die Beschreibbarkeit des
	 * Eingabefelds für die Auslagenhöhe an die Art des GebührenTatbestands
	 * anzupassen.
	 * 
	 */
	public void adjustAuslagenHoeheVisibility() {
		GebuehrenTatbestand gt = (GebuehrenTatbestand) this.cbGebuehrenListe.getSelectedItem();
		if (gt instanceof AuslagenTatbestand && ((AuslagenTatbestand) gt).getBetrag() <= 0.0) {
			this.aktiviereFtfAuslagenHoehe();
			this.lblAuslagenHoehe.setText(GebuehrHinzufuegenDialog.AUSLAGEN_HOEHE_TEXT);
		} else if (gt instanceof GebuehrenErhoehungsTatbestand
				&& ((GebuehrenErhoehungsTatbestand) gt).getAnzahl() < 0) {
			this.aktiviereFtfAuslagenHoehe();
			this.lblAuslagenHoehe.setText(GebuehrHinzufuegenDialog.ANZAHL_TEXT);
		} else
			this.ftfAuslagenHoehe.setEnabled(false);
	}

	/**
	 * Die Methode dient dazu, das Eingabefeld zu aktivieren
	 * 
	 */
	void aktiviereFtfAuslagenHoehe() {
		ftfAuslagenHoehe.setEnabled(true);
		if (ftfAuslagenHoehe.getText() == null || "".equals(ftfAuslagenHoehe.getText()))
			ftfAuslagenHoehe.setText("0");
	}
}