/**
 * GebuehrenTabelleDruckenAction.java
 * eu.gronos.kostenrechner.view.panel (Kostenrechner)
 */
package eu.gronos.kostenrechner.controller.gebuehren;

import java.awt.event.ActionEvent;
import java.awt.print.PrinterException;
import java.text.MessageFormat;

import javax.swing.KeyStroke;
import javax.swing.Action;
import javax.swing.JTable;
import javax.swing.JTable.PrintMode;

import eu.gronos.kostenrechner.Kostenrechner;
import eu.gronos.kostenrechner.controller.BeschriebeneAktion;
import eu.gronos.kostenrechner.view.gebuehren.GebuehrenBerechnungPanel;
import eu.gronos.kostenrechner.view.helpanderror.FehlerDialog;

/**
 * Die {@link Action} druckt den Inhalt der Streitwerttabelle über
 * {@link JTable#print()}
 *
 * @author Peter Schuster (setrok)
 * @date 04.11.2018
 *
 */
public class GebuehrenTabelleDruckenAction extends BeschriebeneAktion {
	private final GebuehrenBerechnungPanel panel;
	private static final long serialVersionUID = 8046359053768482197L;

	/**
	 * Konstruktor.
	 * 
	 * @param panel            Verweis auf {@link GebuehrenBerechnungPanel}
	 * @param name             {@link Action#NAME}
	 * @param shortDescription {@link Action#SHORT_DESCRIPTION}
	 * @param mnemonic         {@link Action#MNEMONIC_KEY}
	 * @param actionCommandKey {@link Action#ACTION_COMMAND_KEY}
	 * @param acceleratorKey   {@link Action#ACCELERATOR_KEY}
	 */
	public GebuehrenTabelleDruckenAction(GebuehrenBerechnungPanel panel, String name, String shortDescription,
			int mnemonic, String actionCommandKey, KeyStroke acceleratorKey) {
		super(name, shortDescription, mnemonic, actionCommandKey, acceleratorKey);
		this.panel = panel;
	}

	@Override
	public void actionPerformed(ActionEvent e) {
		try {
			boolean fertig = panel.getTabStreitwertTabelle().print(PrintMode.FIT_WIDTH,
					new MessageFormat("Streitwerttabelle"), new MessageFormat(
							Kostenrechner.KOSTENRECHNER_TITLE + Kostenrechner.KOSTENRECHNER_VERSION + "\t Seite {0}"));
			if (fertig)
				;
		} catch (PrinterException pe) {
			new FehlerDialog(FehlerDialog.FEHLER_BLANKO, GebuehrenBerechnungPanel.FEHLER_DRUCKEN, pe).showDialog();
		}
	}
}